require "import"
import "android.widget.*"
import "android.view.*"
import "cjson"

messages = {}

function urlEncode(text)
  text = tostring(text)
  text = text:gsub("\n", "\r\n")
  text = text:gsub("([^%w %-%_%.%~])", function(c)
    return string.format("%%%02X", string.byte(c))
  end)
  text = text:gsub(" ", "+")
  return text
end

function cleanText(text)
  local cleanedText = cjson.decode(text) 
  if cleanedText then
    cleanedText = cleanedText.answer
    return cleanedText
  else
    return "النص غير متاح أو حدث خطأ."
  end
end

function addMessage(container, title, message)
  local fullMessage = title .. " " .. message
  local messageLayout = {
    TextView;
    text = fullMessage;
    textSize = "16sp";
    textColor = "#ffffff";
    padding = "10dp";
  }
  local textView = TextView(service)
  container.addView(textView)
  textView.setText(message)
  table.insert(messages, message)
  textView.setTextColor(0xFFFFFFFF)
  textView.setTextSize(16)
if message == "ChatGPT is writing now..." then
    container.removeViewAt(container.getChildCount() - 1)
  end
  textView.setOnLongClickListener(function(view)
    text = textView.getText()
    codes = {}
    for full_pattern, pattern_content in string.gmatch(text, "```(.-)\n(.-)\n```") do
        table.insert(codes, pattern_content)
    end
    if #codes > 0 then
      for i, code in ipairs(codes) do
        print(code)
      end
  else
  service.copy(text)
    end
  end)
end

layout = {
  LinearLayout;
  orientation = "vertical";
  layout_width="match_parent";
  layout_height="match_parent";
  backgroundColor = "#000000";
  { 
    RelativeLayout;
    layout_width="match_parent";
    layout_height="match_parent";
    backgroundColor = "#000000";

    {
      EditText;
hint = "message";
      id = "question";
      InputType = "textMultiLine";
      layout_width="match_parent";
      layout_height="wrap_content";
      layout_alignParentLeft=true;      
      layout_marginRight="100dp";   
    };    
    {
      Button;
      text = ">";
contentDescription = "Send";
      id = "sendButton";
      textColor = "#000000";
      backgroundColor = "#ffffff";
      layout_width="40sp";
        layout_height="wrap_content";
        layout_alignParentRight=true;
        onClick = function(view)
        local sendButton = view
        local questionText = question.text
        if questionText == "" then
service.postSpeak(200, "Enter your message first")
          return
        end
        local encodedQuestion = urlEncode(questionText)
        local url = "https://chatgpt.apinepdev.workers.dev/?question=" .. encodedQuestion
        addMessage(messagesContainer, "أنت:", questionText)
service.postSpeak(200, "ChatGPT is writing now...")
          Http.get(url, function(status, data)
          if status == 200 then
            local cleanedData = cleanText(data)
            addMessage(messagesContainer, "ChatGPT:", cleanedData)
            service.postSpeak(200, cleanedData)
            question.setText("")
          else
local errorMessage = "An error occurred while processing the request."
            addMessage(messagesContainer, "خطأ:", errorMessage)
            service.postSpeak(200, errorMessage)
            sendButton.setText("إرسال")
          end
        end)
      end;
    };
  };
  {
    Button;
    text = "+";
    backgroundColor = "#000000";   
contentDescription = "New conversation";
    layout_width = "match_parent";
    layout_height = "wrap_content";
    onClick = function()
      messagesContainer.removeAllViews()
      table.clear(messages)
    end;
  };
  {
    Button;
    text = "[■]";
    backgroundColor = "#000000";   
contentDescription = "Save the conversation to a text file";
    layout_width = "match_parent";
    layout_height = "wrap_content";
    onClick = function()
      save_layout = {
        LinearLayout;
        orientation = "vertical";
        layout_width="match_parent";
        layout_height="match_parent";
        backgroundColor = "#000000";
        {
          EditText;
hint = "Enter file name";
          id = "fileEdit";
          layout_width="match_parent";
          layout_height="wrap_content";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";        
        };
        {
          Button;
text = "save";
          backgroundColor = "#000000";
          layout_width = "match_parent";
          layout_height = "wrap_content";
          onClick = function()
            name = fileEdit.text
            save_dlg.dismiss()
            if name ~= "" then              
              filename = "sdcard/解说/SavedChats/" .. name .. ".txt"
              os.execute("mkdir -p sdcard/解说/SavedChats")
              file = io.open(filename, "w")
              if #messages > 0 then                                         
                for i, message in ipairs(messages) do
                  file:write(message .. "\n")
                end
                file:close() 
service.postSpeak(200, "The file was saved successfully")
              else
service.postSpeak(200, "You cannot save an empty conversation")
              end
            else
service.postSpeak(200, "Enter file name first")
            end
          end;            
        };
      }
      save_dlg = LuaDialog()
save_dlg.setTitle("Save conversation")
      save_dlg.setView(loadlayout(save_layout))
      save_dlg.show()
    end;
  };
  {
    Button;
    text = "~~~";
contentDescription = "Saved conversations";
    backgroundColor = "#000000";
    layout_width = "match_parent";
    layout_height = "wrap_content";  
    onClick = function()
      save_layout = {
        LinearLayout;
        orientation = "vertical";
        layout_width="match_parent";
        layout_height="match_parent";
        backgroundColor = "#000000";
        {
          ListView;
          id = "saved";
          backgroundColor = "#000000";   
          layout_width = "match_parent";
          layout_height = "match_parent";
        };
      }
      saved_dlg = LuaDialog()
saved_dlg.setTitle("Saved conversations")
      saved_dlg.setView(loadlayout(save_layout))
      saved_dlg.show()
      local chats_folder = "/sdcard/解说/SavedChats"
      local dir = io.popen("ls -t " .. chats_folder)
      local chats = {}
      for chat in dir:lines() do
        chat = chat:gsub(".txt", "")
        table.insert(chats, chat)
      end
      dir:close()
      saved.adapter = ArrayAdapter(service, android.R.layout.simple_list_item_1, chats)
      saved.onItemClick = function(parent, view, position, id)
        chat = saved.getItemAtPosition(position)
        filename = "sdcard/解说/SavedChats/" .. chat .. ".txt"
        lines = {}
        file = io.open(filename, "r")
        for line in file:lines() do
          print(line)
        end
      end
    end;
  };
  {
    Button;
    text = "×"; 
    backgroundColor = "#000000";   
contentDescription = "exit";
    layout_width = "match_parent";
    layout_height = "wrap_content";
    onClick = function()
      dlg.dismiss()
    end;
  };
  {
    ScrollView;
    layout_width = "match_parent";
    layout_height = "match_parent";
    {
      LinearLayout;
      id = "messagesContainer";
      orientation = "vertical";
      layout_width = "match_parent";
      layout_height = "wrap_content";
      padding = "10dp";
    };
  };
}
dlg = LuaDialog()
dlg.setTitle("ChatGPT")
dlg.setView(loadlayout(layout))
dlg.show()
